var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
import require$$0, { createContext, useState, useRef, useEffect, useContext, useReducer } from "react";
import DyteClient from "@dytesdk/web-core";
var jsxRuntime = { exports: {} };
var reactJsxRuntime_production_min = {};
/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var hasOwnProperty = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;
function toObject(val) {
  if (val === null || val === void 0) {
    throw new TypeError("Object.assign cannot be called with null or undefined");
  }
  return Object(val);
}
function shouldUseNative() {
  try {
    if (!Object.assign) {
      return false;
    }
    var test1 = new String("abc");
    test1[5] = "de";
    if (Object.getOwnPropertyNames(test1)[0] === "5") {
      return false;
    }
    var test2 = {};
    for (var i = 0; i < 10; i++) {
      test2["_" + String.fromCharCode(i)] = i;
    }
    var order2 = Object.getOwnPropertyNames(test2).map(function(n2) {
      return test2[n2];
    });
    if (order2.join("") !== "0123456789") {
      return false;
    }
    var test3 = {};
    "abcdefghijklmnopqrst".split("").forEach(function(letter) {
      test3[letter] = letter;
    });
    if (Object.keys(Object.assign({}, test3)).join("") !== "abcdefghijklmnopqrst") {
      return false;
    }
    return true;
  } catch (err) {
    return false;
  }
}
shouldUseNative() ? Object.assign : function(target, source) {
  var from;
  var to = toObject(target);
  var symbols;
  for (var s = 1; s < arguments.length; s++) {
    from = Object(arguments[s]);
    for (var key in from) {
      if (hasOwnProperty.call(from, key)) {
        to[key] = from[key];
      }
    }
    if (getOwnPropertySymbols) {
      symbols = getOwnPropertySymbols(from);
      for (var i = 0; i < symbols.length; i++) {
        if (propIsEnumerable.call(from, symbols[i])) {
          to[symbols[i]] = from[symbols[i]];
        }
      }
    }
  }
  return to;
};
/** @license React v17.0.2
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var f = require$$0, g = 60103;
reactJsxRuntime_production_min.Fragment = 60107;
if (typeof Symbol === "function" && Symbol.for) {
  var h = Symbol.for;
  g = h("react.element");
  reactJsxRuntime_production_min.Fragment = h("react.fragment");
}
var m = f.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, n = Object.prototype.hasOwnProperty, p = { key: true, ref: true, __self: true, __source: true };
function q(c, a, k) {
  var b, d = {}, e = null, l = null;
  k !== void 0 && (e = "" + k);
  a.key !== void 0 && (e = "" + a.key);
  a.ref !== void 0 && (l = a.ref);
  for (b in a)
    n.call(a, b) && !p.hasOwnProperty(b) && (d[b] = a[b]);
  if (c && c.defaultProps)
    for (b in a = c.defaultProps, a)
      d[b] === void 0 && (d[b] = a[b]);
  return { $$typeof: g, type: c, key: e, ref: l, props: d, _owner: m.current };
}
reactJsxRuntime_production_min.jsx = q;
reactJsxRuntime_production_min.jsxs = q;
{
  jsxRuntime.exports = reactJsxRuntime_production_min;
}
const jsx = jsxRuntime.exports.jsx;
class DyteUpdates {
  constructor(meeting) {
    __publicField(this, "meeting");
    __publicField(this, "l");
    this.meeting = meeting;
    this.l = /* @__PURE__ */ new Set();
    this.meeting.self.addListener("*", this.update.bind(this));
    this.meeting.meta.addListener("*", this.update.bind(this));
    this.meeting.participants.addListener("*", this.update.bind(this));
    this.meeting.participants.joined.addListener("*", this.update.bind(this));
    this.meeting.participants.active.addListener("*", this.update.bind(this));
    this.meeting.chat.addListener("*", this.update.bind(this));
    this.meeting.plugins.addListener("*", this.update.bind(this));
  }
  clean() {
    this.meeting.self.removeListener("*", this.update.bind(this));
    this.meeting.meta.removeListener("*", this.update.bind(this));
    this.meeting.participants.removeListener("*", this.update.bind(this));
    this.meeting.participants.joined.removeListener("*", this.update.bind(this));
    this.meeting.participants.active.removeListener("*", this.update.bind(this));
    this.meeting.chat.removeListener("*", this.update.bind(this));
    this.meeting.plugins.removeListener("*", this.update.bind(this));
  }
  addListener(listener) {
    this.l.add(listener);
  }
  removeListener(listener) {
    this.l.delete(listener);
  }
  update() {
    this.l.forEach((l) => {
      l();
    });
  }
}
const DyteContext = createContext({
  meeting: void 0,
  updates: void 0
});
function DyteProvider({
  value,
  children,
  renderBeforeLoad
}) {
  const [updates, setUpdates] = useState();
  const updatesRef = useRef();
  useEffect(() => {
    if (value) {
      setUpdates(new DyteUpdates(value));
    }
    return () => {
      var _a;
      (_a = updatesRef.current) == null ? void 0 : _a.clean();
    };
  }, [value]);
  if (!value && !renderBeforeLoad)
    return null;
  return /* @__PURE__ */ jsx(DyteContext.Provider, {
    value: {
      meeting: value,
      updates
    },
    children
  });
}
DyteProvider.defaultProps = {
  renderBeforeLoad: false
};
const useDyteMeeting = () => useContext(DyteContext);
const useDyteClient = () => {
  const [client, setClient] = useState();
  const initClient = async (options) => {
    const cli = await DyteClient.init(options);
    setClient(cli);
    return cli;
  };
  return [client, initClient];
};
const shouldUpdate = (slice, newSlice) => {
  if (slice !== newSlice) {
    return true;
  }
  if (Array.isArray(slice) && Array.isArray(newSlice)) {
    if (slice.length !== newSlice.length) {
      return true;
    }
  }
  return false;
};
const useDyteSelector = (selector) => {
  const { meeting, updates } = useDyteMeeting();
  const state = useRef(meeting && selector(meeting));
  const [, forceUpdate] = useReducer((c) => c + 1, 0);
  useEffect(() => {
    const currentState = meeting && selector(meeting);
    const listener = () => {
      const newStateSlice = meeting && selector(meeting);
      if (shouldUpdate(state.current, newStateSlice)) {
        state.current = newStateSlice;
        forceUpdate();
      }
    };
    if (currentState && typeof currentState === "object" && "addListener" in currentState) {
      currentState.addListener("*", forceUpdate);
      return () => {
        currentState.removeListener("*", forceUpdate);
      };
    }
    updates == null ? void 0 : updates.addListener(listener);
    return () => {
      updates == null ? void 0 : updates.removeListener(listener);
    };
  }, [meeting, updates]);
  return state.current;
};
export { DyteProvider, useDyteClient, useDyteMeeting, useDyteSelector };
