import DyteClient from '@dytesdk/web-core';
interface DyteClientOptions {
    roomName: string;
    authToken: string;
    apiBase?: string;
    defaults?: {
        video?: boolean;
        audio?: boolean;
    };
}
/**
 * Hook which manages a DyteClient instance
 */
export declare const useDyteClient: () => [DyteClient | undefined, (options: DyteClientOptions) => {}];
declare type StateSelector<T extends object, U> = (state: T) => U;
/**
 * Hook which extracts data from the DyteClient object
 */
export declare const useDyteSelector: <StateSlice>(selector: StateSelector<DyteClient, StateSlice>) => StateSlice | undefined;
export * from './context';
